#ifndef CONFIGHANDLER_H_
#define CONFIGHANDLER_H_

#include "struct.h"
#include "xml_parser.h"

// --------------------------------------------------------------------
// DEFINES
// --------------------------------------------------------------------
// system
#define D_SHOW_DEBUG				false
#define D_SHOW_MESSAGES				true
#define D_SHOW_WARNINGS				true
#define D_SHOW_ERRORS				true

#define D_GC_RECORD_TIME			32000						// 32000 ~ 2 seconds
#define D_DICTATE_PAUSE				4000						// 3500 ~ 3.5s

// paths
#define D_PATH_RESX					"etc/gcompris/res"			// from home dir
#define D_PATH_MP3					"trimmed"					// not configurable - dir within PATH_RESX with mp3/wav files
#define D_PATH_IMG					"img"						// not configurable - dir within PATH_RESX with image/graphic files
#define D_PATH_HTK					"_htk"						// not configurable - dir within PATH_RESX with files needed by speech recognizer

// files
#define D_GLADE_FILE				"AppWindow.glade"
#define D_PRG_ICON					"readtutorapi.png"
#define D_CONFIG_FILE				"config.xml"

#define D_STORY_FILE				"index_seg.xml"
#define D_PICTURE_FILE				"obrazok_pozadie.jpg"
#define D_HEADER_WAV_FILE			"nadpis.wav"				// not configurable

#define D_PIC_BTN_NEXT				"button_forward.png"		// not configurable
#define D_PIC_BTN_NEXT_DIS			"button_forward_disabled.png"		// not configurable
#define D_PIC_BTN_PREV				"button_backward.png"		// not configurable
#define D_PIC_BTN_PREV_DIS			"button_backward_disabled.png"		// not configurable
#define D_PIC_OPEN_BOOK				"open-book.png"				// not configurable
#define D_PIC_BACKGROUND_IMAGE		"wood3.jpg"
#define D_PIC_BUTTON_STD			"button_large.png"			// not configurable
#define D_PIC_BUTTON_ALT			"button_large_selected.png"	// not configurable
#define D_PIC_BUTTON_DIS			"button_large_disabled.png" // not configurable

#define D_PIC_SMILEY1				"smiley1.png" // not configurable
#define D_PIC_SMILEY2				"smiley2.png" // not configurable
#define D_PIC_SMILEY3				"smiley3.png" // not configurable
#define D_PIC_SMILEY4				"smiley4.png" // not configurable
#define D_PIC_SMILEY5				"smiley5.png" // not configurable

// canvas defines
#define D_CANVAS_ANTI_ALIASED		false				// this mode is not supported during diploma project (we'll see later) - use at your own risk! :: Actualy, it was disabled during configuration.
#define D_CANVAS_WIDTH				800.0
#define D_CANVAS_HEIGHT				520.0
#define D_CANVAS_BORDER				0.0
#define D_CANVAS_BORDER_COLOR		GREY
#define D_CANVAS_BACKGROUND_COLOR	WHITE

#define D_CANVAS_GRID_SHOW			false
#define D_CANVAS_GRID_COLOR			GREY
#define D_CANVAS_GRID_THICK			1.0

// textfield defines
#define D_TEXTF_DOCK				true				// if true, textfield will be docked to the top right
#define D_TEXTF_DOCK_TOP			true
#define D_TEXTF_DOCK_BOTTOM			false
#define D_TEXTF_DOCK_RIGHT			true
#define D_TEXTF_DOCK_TOP_MARGIN		10.0
#define D_TEXTF_DOCK_BOTTOM_MARGIN	10.0
#define D_TEXTF_DOCK_RIGHT_MARGIN	10.0

#define D_TEXTF_WIDTH				550.0
#define D_TEXTF_HEIGHT				358.5
#define D_TEXTF_X					190.0				// coords in board group
#define D_TEXTF_Y					 10.0				// coords in board group
#define D_TEXTF_PADDING				 26.0				// space between outline and text (right/left)
#define D_TEXTF_PADDING_VERT		 10.0				// space between upper/lower border
#define D_TEXTF_BORDER				  2.0				// width of textfield border
#define D_TEXTF_BORDER_COLOR		AQUA_GREEN			// color of textfield border
#define D_TEXTF_BORDER_SHOW			false
#define D_TEXTF_INNER_SHOW			false

// (author) info
#define D_INFO_X					10.0
#define D_INFO_Y					283.0				// musi byt pod Cancel buttonom: 225+48+10 = 283
#define D_INFO_WIDTH				220.0
#define D_INFO_HEIGHT				250.0
#define D_INFO_PADDING				10.0
#define D_INFO_DOCK					true				// turns docking on/off in general for info field
#define D_INFO_DOCK_BOTTOM			10.0				// if this is negative, dock from this side is considered false
#define D_INFO_DOCK_RIGHT			10.0
#define D_INFO_DOCK_LEFT			10.0
#define D_INFO_BORDER				2.0
#define D_INFO_BORDER_SHOW			true
#define D_INFO_BORDER_COLOR			AQUA_GREEN
#define D_INFO_TEXT_SIZE			10 * PANGO_SCALE	// not configurable
#define D_INFO_TEXT_COLOR			BLACK				// not configurable
#define D_INFO_PICTURE_WIDTH		200.0				// should be INFO_WIDTH - 2*INFO_PADDING // not configurable
#define D_INFO_PICTURE_HEIGHT		170.0				// not configurable

// text properties
#define D_TEXT_FAMILY				"Sans"				// Sans, Helvetica, Verdana, Tahoma, Arial, Times, Monospace
#define D_TEXT_SIZE					20
#define D_TEXT_SIZE_HEADING			28
#define D_TEXT_BOLDNESS				400
#define D_TEXT_SPACING_VERT			0.0
#define D_TEXT_SPACING_HORIZ		1.0
#define D_TEXT_HEADLINE_CENTER		true				// center headline
#define D_TEXT_PARAGRAPH_INDEND		"    "				// not configurable // paragraph indendation, set this to "" to turn it off

// font colors
#define D_FONT_COLOR				BLACK
#define D_FONT_BCOLOR				WHITE
#define D_FONT_HLT_COLOR			GREY
#define D_FONT_HLT_BCOLOR			WHITE
#define D_FONT_SELECT_COLOR			DARK_BLUE
#define D_FONT_SELECT_BCOLOR		WHITE
#define D_FONT_SELECT_HLT_COLOR		BLUE
#define D_FONT_SELECT_HLT_BCOLOR	WHITE

// mark colors - see struct.h -> MarkMode enum for details
// these attributes are not configurable in this release
#define D_MARK_COLOR_NONE			BLACK
#define D_MARK_COLOR_CURRENT		BLUE
#define D_MARK_COLOR_PASSED			DARK_BLUE

// font aa colors
#define D_FONT_COLOR_AA				BLACK_AA
#define D_FONT_HLT_COLOR_AA			LIGHT_BLUE_AA
#define D_FONT_BCOLOR_AA			WHITE_AA
#define D_FONT_HLT_BCOLOR_AA		WHITE_AA

// Tooltips
#define D_TIP_SHOW_TOOLTIPS			true			// whether to use tooltips in general
#define D_TIP_COLOR					LIGHT_YELLOW	// tooltip color
#define D_TIP_BORDER_COLOR			BLACK			// outline color
#define D_TIP_BORDER_COLOR_ALT		LIGHT_GREY		// alternate outline color, for plastic shadow effect
#define D_TIP_BORDER_THICK			1.0				// border thickness
#define D_TIP_FONT_COLOR			BLACK			// color of the font
#define D_TIP_FONT_SIZE				18				// this needs to be multiplied by pango scale constant
#define D_TIP_PADDING_HEIGHT		2.0				// distance between border and textitem
#define D_TIP_PADDING_WIDTH			5.0				// detto
#define D_TIP_BORDER_PLASTIC		true			// plastic-like effect

// Buttons
#define D_BUTTON_BORDER_WIDTH		2.0
#define D_BUTTON_BORDER_COLOR		BLACK
#define D_BUTTON_SHADOW_COLOR		LIGHT_GREY
#define D_BUTTON_BACKGROUND_COLOR	AQUA_GREEN
#define D_BUTTON_TEXT_SIZE			10
#define D_BUTTON_TEXT_COLOR			BLACK
#define D_BUTTON_TEXT_COLOR_ALT		LIGHT_GREY
#define D_BUTTON_PLASTIC_ON_MOTION	true			// indicates whether the borders are shown only on mouse motion over the button // not configurable and probably even not used
#define D_BUTTON_WIDTH				50.0
#define D_BUTTON_HEIGHT				24.0
#define D_BUTTON_WIDTH_ICON			190.0			// not configurable - proportions of gcompris-styled buttons
#define D_BUTTON_HEIGHT_ICON		48.0			// not configurable - proportions of gcompris-styled buttons
#define D_BUTTON_SHOW_IMAGE_BUTTONS	true
#define D_BUTTON_SHOW_IMG_LABELS	false			// if set to true, text labes are shown on the image/icon buttons - this is feature of Canvas, not CanvasButtons

// Listbox
#define D_LB_X						10.0
#define D_LB_Y						10.0
#define D_LB_WIDTH					220.0
#define D_LB_HEIGHT					210.0
#define D_LB_BORDER_WIDTH			2.0
#define D_LB_TEXT_SIZE				12
#define D_LB_TEXT_COLOR				BLACK
#define D_LB_BORDER_COLOR			AQUA_GREEN
#define D_LB_PADDING				10.0
// cancel button
#define D_LB_BTN_CANCEL_X			10.0
#define D_LB_BTN_CANCEL_Y			225.0

// gdk colors using color struct sColor
#define D_FONT_COLOR_S				BLACK_S 
#define D_FONT_HLT_COLOR_S			LIGHT_BLUE_S
#define D_FONT_BCOLOR_S				WHITE_S
#define D_FONT_HLT_BCOLOR_S			WHITE_S

// GDK colors
#define BLACK						"#000000"	//   0,   0,   0
#define WHITE						"#FFFFFF"	// 255, 255, 255
#define BLUE						"#AAAAFF"	// 170, 170, 255
#define LIGHT_BLUE					"#8EC7FF"	// 142, 199, 255
#define DARK_BLUE					"#0000C0"	//   0,   0, 192
#define TIRQUISE					"#00C7FF"	//   0, 199, 255
#define GREEN						"#00A000"	//   0, 160,   0
#define DARK_GREEN					"#006400"	//   0, 100,   0
#define LIGHT_GREEN					"#90EE90"	// 144. 238, 144
#define AQUA_GREEN					"#8EFFC7"	// 142, 255, 199
#define YELLOW						"#FFFF00"	// 255, 255,   0
#define LIGHT_YELLOW				"#FFFACD"	// 255, 250, 205
#define GREY						"#7A8B8B"	// 122, 139, 139
#define LIGHT_GREY					"#D3D3D3"	// 211, 211, 211
#define RED							"#FF0000"	// 255,   0,   0

// MARK colors
#define MM_COLOR_0					"#FF0000"	// 255, 000, 000
#define MM_COLOR_20					"#FF3200"	// 255,  50, 000
#define MM_COLOR_30					"#FF6400"	// 255, 100, 000
#define MM_COLOR_40					"#FF9600"	// 255, 150, 000
#define MM_COLOR_50					"#FFC800"	// 255, 200, 000
#define MM_COLOR_60					"#E6D700"	// 230, 215, 000
#define MM_COLOR_70					"#96E600"	// 150, 230, 000
#define MM_COLOR_80					"#4BE600"	//  75, 230, 000
#define MM_COLOR_90					"#00C800"	// 000, 200,   0
#define MM_COLOR_95					"#008200"	// 000, 130,   0
// #define MM_COLOR_95					"#8EC7FF"	// 142, 199, 255 // svetlo modra

// AA colors
#define BLACK_AA					0x000000FF	//   0,   0,   0
#define WHITE_AA					0xFFFFFFFF	// 255, 255, 255
#define BLUE_AA						0xAAAAFFFF	// 170, 170, 255
#define LIGHT_BLUE_AA				0x8EC7FFFF	// 142, 199, 255
#define DARK_BLUE_AA				0x0000C0FF	//   0,   0, 192
#define TIRQUISE_AA					0x00C7FFFF	//   0, 199, 255
#define GREEN_AA					0x006400FF	//   0, 100,   0
#define LIGHT_GREEN_AA				0x8EFFC7FF	// 142, 255, 199
#define AQUA_GREEN_AA				0x8EFFC7FF	// 142, 255, 199
#define YELLOW_AA					0xFFFF00FF	// 255, 255,   0
#define LIGHT_YELLOW_AA				0xFFFACDFF	// 255, 250, 205
#define GREY_AA						0x7A8B8BFF	// 122, 139, 139
#define LIGHT_GREY_AA				0xD3D3D3FF	// 211, 211, 211

// misc
#define WORD_DELIMITER				"  "

/**
 * Mar 1, 2007 10:18:28 PM
 * 
 * Handles reading and writing .xml configuration files.
 * 
 */
class ConfigHandler
{
	public:
		ConfigHandler (char* configFileName);
	   ~ConfigHandler ();
		// --------------------------------------------------------------------
		// METHODS 			- PUBLIC
		// --------------------------------------------------------------------
		void WriteDefaultsToFile (const char* fileName);
		
		// --------------------------------------------------------------------
		// PROPERTIES 		- PUBLIC
		// --------------------------------------------------------------------
		// system
		gboolean ShowDebug ();
		gboolean ShowMessages ();
		gboolean ShowWarnings ();
		gboolean ShowErrors ();
		
		// paths
		char* PathResx ();
		
		// files
		char* GladeFile ();
		char* PrgIcon ();
		char* ConfigFile ();
		char* StoryFile ();
		char* PictureFile ();
		char* PicBackgroundImage ();
		
		// canvas
		gboolean CanvasAntiAliased ();
		double CanvasWidth ();
		double CanvasHeight ();
		double CanvasBorder ();
		char* CanvasBorderColor ();
		char* CanvasBackgroundColor ();
		
		gboolean CanvasGridShow ();
		char* CanvasGridColor ();
		double CanvasGridThick ();
		
		// textfield
		gboolean TextfDock ();
		gboolean TextfDockTop ();
		gboolean TextfDockBottom ();
		gboolean TextfDockRight ();
		double TextfDockTopMargin ();
		double TextfDockBottomMargin ();
		double TextfDockRightMargin ();
		
		double TextfWidth ();
		double TextfHeight ();
		double TextfY ();
		double TextfX ();
		double TextfPadding ();
		double TextfPaddingVert ();
		double TextfBorder ();
		char* TextfBorderColor ();
		gboolean TextfBorderShow ();
		gboolean TextfInnerShow ();
		
		// (author) info
		double InfoX ();
		double InfoY ();
		double InfoWidth ();
		double InfoHeight ();
		double InfoPadding ();
		gboolean InfoDock ();
		double InfoDockBottom ();
		double InfoDockRight ();
		double InfoDockLeft ();
		double InfoBorder ();
		gboolean InfoBorderShow ();
		char* InfoBorderColor ();
		
		// text
		char* TextFamily ();
		int TextSize ();
		int TextSizeHeading ();
		double TextSpacingVert ();
		double TextSpacingHoriz ();
		gboolean TextHeadlineCenter ();
		char* TextParagraphIndend ();
		
		// font colors
		char* FontColor ();
		char* FontBColor ();
		char* FontHltColor ();
		char* FontHltBColor ();
		char* FontSelectColor ();
		char* FontSelectBColor ();
		char* FontSelectHltColor ();
		char* FontSelectHltBColor ();
		
		// font aa colors
		int FontColorAA ();
		int FontHltColorAA ();
		int FontBColorAA ();
		int FontHltBColorAA ();
		
		// tooltips
		gboolean TipShowTooltips ();
		char* TipColor ();
		char* TipBorderColor ();
		char* TipBorderColorAlt ();
		char* TipFontColor ();
		double TipBorderThick ();
		int TipFontSize ();
		double TipPaddingWidth ();
		double TipPaddingHeight ();
		gboolean TipBorderPlastic ();
		
		// buttons
		double ButtonBorderWidth ();
		char* ButtonBorderColor ();
		char* ButtonShadowColor ();
		char* ButtonBackgroundColor ();
		int ButtonTextSize ();
		char* ButtonTextColor ();
		char* ButtonTextColorAlt ();
		double ButtonWidth ();
		double ButtonHeight ();
		gboolean ButtonShowImageButtons ();
		gboolean ButtonShowImgLabels ();
		
		// listbox
		double LbX ();
		double LbY ();
		double LbWidth ();
		double LbHeight ();
		double LbBorderWidth ();
		int LbTextSize ();
		char* LbTextColor ();
		char* LbBorderColor ();
		double LbPadding ();
		double LbBtnCancelX ();
		double LbBtnCancelY ();
		
		// --------------------------------------------------------------------
		// ATTRIBUTES 		- PUBLIC
		// --------------------------------------------------------------------
	
	private:
		// --------------------------------------------------------------------
		// METHODS 			- PRIVATE
		// --------------------------------------------------------------------
		string getValue (XMLNode node, char* attName);
		string getText (XMLNode node);
		
		char* ParseColor (string color);
		int ParseColor_AA (string color);
		char* ColorToString (char* color_str);
		char* ColorToString_AA (int color_code);
		
		// --------------------------------------------------------------------
		// EVENTS 			- PRIVATE
		// --------------------------------------------------------------------
		
		// --------------------------------------------------------------------
		// ATTRIBUTES 		- PRIVATE
		// --------------------------------------------------------------------
		XMLNode config;		// .xml document's root node
		
		gboolean show_debug, show_messages, show_warnings, show_errors;
		
};

#endif /*CONFIGHANDLER_H_*/
