#ifndef CANVAS_TIPS_H_
#define CANVAS_TIPS_H_

#include "struct.h" // using gnome.h

// TYPES
typedef struct _CanvasTip CanvasTip;
typedef struct _CanvasTipDesc CanvasTipDesc;


// STRUCTURES
struct _CanvasTip
{
	GnomeCanvasItem *root_grp;
	GnomeCanvasItem *background;
	GnomeCanvasItem *text;
	GnomeCanvasItem *image;
};

struct _CanvasTipDesc
{
	// label
	char*		label;
	char*		font_color;
	int			font_size;
	
	GdkPixbuf *img;
	
	// background
	char*		fill_color;
	char*		border_color;
	char*		border_color_alt;
	double		border_thick;
	gboolean	border_plastic;
	
	// general
	double		padding_width;
	double		padding_height;
};

// FUNCTIONS
CanvasTip* canvas_tip_new (GnomeCanvasGroup *parent, CanvasTipDesc* tip_desc);
void canvas_tip_destroy (CanvasTip *tip);

CanvasTipDesc*	canvas_tip_desc_new ();
void			canvas_tip_desc_free (CanvasTipDesc *desc);
CanvasTipDesc*	canvas_tip_desc_duplicate (CanvasTipDesc *desc);

#endif /*CANVAS_TIPS_H_*/
