#ifndef XML_H_
#define XML_H_

#define VERSION_XML "0.9"

#include "struct.h"
#include "xml_parser.h"

/**
 * Jan 16, 2007 11:26:26 AM
 * 
 * Handles all XML data.
 * 
 */
class Xml
{
	public:
		Xml(int mode);
	   ~Xml();
		// --------------------------------------------------------------------
		// METHODS		- PUBLIC
		// --------------------------------------------------------------------
		bool	ReadFile (string fileName);
		void	PrintInfo ();
		void	PrintStoryText ();
		string	GetPersonInfo ();
static	string	GetVersion ();
static	string	GetVersionInfo ();
		void	PrintVersionInfo ();
		PersonData* GetPersonData ();
		
		StoryInfo*	CheckDirectory (gchar* fullPath, gchar* dir_name);

		// --------------------------------------------------------------------
		// PROPERTIES 	- PUBLIC
		// --------------------------------------------------------------------
		// misc info
		string	getId ();
		string	getLanguage ();
		string	getSound ();
		string	getWordSounds ();
		string	getPicture ();
		bool	hasSound ();
		bool	hasWordSounds ();
		bool	hasPicture ();
		// person info
		string	getName ();
		string	getSurname ();
		string	getAge ();
		string	getGrade ();
		string	getGender ();
		string	getSchool ();
		string	getAddress ();
		string	getCity ();
		string	getState ();
		string	getPseudo ();
		string	getTeacher ();
		string	getIdSchool ();
		// texts
		string	getHeadlineText ();
		string	getStoryText ();
		sStory	getStoryWords ();
		
		// --------------------------------------------------------------------
		// ATTRIBUTES 	- PUBLIC
		// --------------------------------------------------------------------
		
	
	private:
		// --------------------------------------------------------------------
		// METHODS 		- PRIVATE
		// --------------------------------------------------------------------
		string	getValue (XMLNode node, char* attName);
		string	getText  (XMLNode node);
		// --------------------------------------------------------------------
		// ATTRIBUTES 	- PRIVATE
		// --------------------------------------------------------------------
		XMLNode	root;
		XMLNode	person;
		XMLNode	headline;
		XMLNode	story;
};


int mainxml (int argc, char* argv[]);

#endif /*XML_H_*/
